<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');
require FORUM_ROOT.'include/common.php';

$forum_id = isset($_GET['forum_id']) ? intval($_GET['forum_id']) : 0;
$username = isset($_GET['username']) ? $_GET['username'] : '';

if (!$forum_user['is_guest'] && $forum_id > 0 && !empty($username)) 
{
	$query = array(
		'SELECT'	=> 'u.id, u.username',
		'FROM'		=> 'users u',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=\''.$forum_db->escape($forum_id).'\' AND fp.group_id=u.group_id)'
			),
			array(
				'LEFT JOIN'		=> 'groups AS g',
				'ON'			=> 'g.g_id=u.group_id'
			)
		),
		'WHERE'		=> 'u.id > 1 AND u.group_id != '.FORUM_UNVERIFIED.' AND u.username LIKE \'%'.$forum_db->escape($username).'%\' AND (fp.read_forum IS NULL OR fp.read_forum=1) AND g.g_read_board=1',
		'ORDER BY'	=> 'u.username LIKE \''.$forum_db->escape($username).'%\' DESC, u.username',
		'LIMIT'		=> '5'
	);

	if ($forum_db->field_exists('groups', 'link_color')) 
	{
	    $query['SELECT'] .= ', g.link_color';
		$link_color_selected = true;
	}

	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$userlist = [];
	$user_ids = [];
    $user_color = [];
	while ($user = $forum_db->fetch_assoc($result)) 
	{
		$userlist[] = $user['username'];
		$user_ids[] = $user['id'];
		
		if (isset($link_color_selected))
			$user_color[] = $user['link_color'];
	}
	
	if (count($userlist) > 0) {
	    echo json_encode(array('answer'=>1,'users'=>$userlist,'ids'=>$user_ids,'colors'=>$user_color));
        die;
    } else {
		echo json_encode(array('answer'=>0));
        die;
	}
}
