
var snSelectedItem = -1;
var sn_search_initialize = function() {
	var textbox = sn_get_textarea();
	$(textbox).keyup(sn_search_keyup);
	$(textbox).keydown(sn_search_keydown);
	$(textbox).keypress(sn_search_keypress);
	$(textbox).click(sn_search);
	$(textbox).blur(sn_search);
	$('body').append('<div id="found_nicks"></div>');
}

PUNBB.common.addDOMReadyEvent(sn_search_initialize);

function sn_search() {
	var textbox = sn_get_textarea(),
	    pos = $(textbox).caret(),
	    search = '',
	    isValid = false;

	for (var i = pos-1; i >= 0; i--) {
		var char = textbox.value.charAt(i).toLowerCase();
		if (char.match(/[a-z0-9\-]/)) {
			search = char + search;
		}
		else {
			if (char == '@') {
				if (i == 0 || textbox.value.charAt(i-1).match(/\s/)) {
					isValid = true;
				}
			}
			break;
		}
	}

	if (isValid && search.length > 0) {
		$.getJSON( PUNBB.env.base_url+'/extensions/smart_nick_to_form/ajax.php',{forum_id:SMART_NICK_TO_FORM.conf.forum_id, username:search},function(data){
			if (data.answer > 0) {
				sn_show_search_results(data.users, data.ids, data.colors);
			} else {
				sn_hide_search_results();
			}
	    });
	}
	else {
		sn_hide_search_results();
	}
}

function sn_show_search_results(names, ids, colors) {
	if (names.length == 0 || ids.length == 0) {
		sn_hide_search_results();
		return;
	}

	var text = '';
	
	if (colors.length > 0) {
	    for (var i = 0; i < names.length; i++) {
		     text += '<p id="sn_user_'+i+'" onmousedown="sn_replace_name(\''+names[i]+'\',\''+ids[i]+'\',\''+colors[i]+'\'); return false;" onmouseover="sn_select_item('+i+');">' + names[i] + '</p>';
	    }
	} else {
		for (var i = 0; i < names.length; i++) {
		     text += '<p id="sn_user_'+i+'" onmousedown="sn_replace_name(\''+names[i]+'\',\''+ids[i]+'\'); return false;" onmouseover="sn_select_item('+i+');">' + names[i] + '</p>';
	    }
	}

	var textbox = sn_get_textarea(),
	    pos = $(textbox).caret(),
	    textboxPosition = $(textbox).offset(),
	    caretPosition = getCaretCoordinates(textbox, pos),
	    elem = document.getElementById('found_nicks');
	elem.style.top = (caretPosition.top + textboxPosition.top - $(textbox).scrollTop() + 20) + 'px';
	elem.style.left = (caretPosition.left + textboxPosition.left + 10) + 'px';
	elem.innerHTML = text;
	elem.style.display = 'inline-block';
	sn_select_item(0);
}

function sn_replace_name(name, id, color) {
	if (name && id) {
	    var textbox = sn_get_textarea(),
	        pos = $(textbox).caret(),
	        start = textbox.value.substr(0, pos),
	        end = textbox.value.substr(pos),
	        atPos = start.lastIndexOf('@');

		if (typeof color !== 'undefined' && color !== 'null') {
	        textbox.value = start.substr(0, atPos) + '[user='+id+' color='+color+']'+name+'[/user], ' + end;
		} else {
			textbox.value = start.substr(0, atPos) + '[user='+id+']'+name+'[/user], ' + end;
		}
			
	    $(textbox).caret(textbox.value.length - end.length);
	    sn_hide_search_results();
	}
}

function sn_hide_search_results() {
	$("#found_nicks").hide();
	snSelectedItem = -1;
}

function sn_search_keyup(evt) {
	sn_disableKeys(evt);
	var code = evt.keyCode ? evt.keyCode : evt.which;
    if (code == 27)
		sn_hide_search_results();
	else if ($("#found_nicks").is(":hidden") || (code != 38 && code != 40 && (code != 13 || snSelectedItem == -1)))
		sn_search();
}

function sn_search_keydown(evt) {
	if ($("#found_nicks").is(":hidden")) return;
	
	sn_disableKeys(evt);
	
	var newSelection = snSelectedItem,
	    code = evt.keyCode ? evt.keyCode : evt.which;

    switch (code) {
        case 38:
			// arrow up
            newSelection--;
            break;
        case 40:
			// arrow down
            newSelection++;
            break;
		case 13:
			// enter
			$('#sn_user_'+snSelectedItem).mousedown();
			return;
		default:
			return;
    }
	
	var pList = $('#found_nicks').find('p');
	if (newSelection < 0) {
		newSelection = pList.length - 1;
	}
	else if (newSelection >= pList.length) {
		newSelection = 0;
	}
	
	sn_select_item(newSelection);
}

function sn_search_keypress(evt) {
	sn_disableKeys(evt);
}

function sn_disableKeys(evt) {
	if ($("#found_nicks").is(":hidden")) return;
	
	var code = evt.keyCode ? evt.keyCode : evt.which;
    switch (code) {
		case 13: // enter
			if (snSelectedItem == -1) return;
		case 27: // esc
        case 38: // arrow up
        case 40: // arrow down
			evt.preventDefault();
    }
}

function sn_select_item(selectedItem) {
	if ($('#sn_user_'+snSelectedItem).length) {
		$('#sn_user_'+snSelectedItem).removeClass('nick_hover');
	}
	
	if ($('#sn_user_'+selectedItem).length) {
		$('#sn_user_'+selectedItem).addClass('nick_hover');
		snSelectedItem = selectedItem;
	}
	else {
		snSelectedItem = -1;
	}
}

function sn_get_textarea() {
	return (document.all) ? document.all.req_message : ((document.getElementById('afocus')!==null) ? (document.getElementById('afocus').req_message) : (document.getElementsByName('req_message')[0]));
}